Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Class RuntimeInstance

    java.lang.Object
      org.apache.velocity.runtime.RuntimeInstance

All Implemented Interfaces:
  RuntimeConstants, RuntimeLogger, RuntimeServices

public class RuntimeInstance
extends Object
implements RuntimeConstants, RuntimeServices

This is the Runtime system for Velocity. It is the single access point for all functionality in Velocity. It adheres to the mediator pattern and is the only structure that developers need to be familiar with in order to get Velocity to perform. The Runtime will also cooperate with external systems like Turbine. Runtime properties can set and then the Runtime is initialized. Turbine, for example, knows where the templates are to be loaded from, and where the Velocity log file should be placed. So in the case of Velocity cooperating with Turbine the code might look something like the following:

> `

>      ri.setProperty(Runtime.FILE_RESOURCE_LOADER_PATH, templatePath);
>      ri.setProperty(Runtime.RUNTIME_LOG, pathToVelocityLog);
>      ri.init();

> `

     -----------------------------------------------------------------------
     N O T E S  O N  R U N T I M E  I N I T I A L I Z A T I O N
     -----------------------------------------------------------------------
     init()

     If init() is called by itself the RuntimeInstance will initialize
     with a set of default values.
     -----------------------------------------------------------------------
     init(String/Properties)

     In this case the default velocity properties are layed down
     first to provide a solid base, then any properties provided
     in the given properties object will override the corresponding
     default property.
     -----------------------------------------------------------------------

Version:
  $Id: RuntimeInstance.java 898050 2010-01-11 20:15:31Z nbubna $
Author:
  Jason van Zyl, Jeff Bowden, Geir Magusson Jr.

Field Summary

Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants
`COUNTER_INITIAL_VALUE, COUNTER_NAME, DEBUG_PREFIX, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_PROPERTIES, DEFINE_DIRECTIVE_MAXDEPTH, DIRECTIVE_IF_TOSTRING_NULLCHECK, ENCODING_DEFAULT, ERROR_PREFIX, ERRORMSG_END, ERRORMSG_START, EVALUATE_CONTEXT_CLASS, EVENTHANDLER_INCLUDE, EVENTHANDLER_INVALIDREFERENCES, EVENTHANDLER_METHODEXCEPTION, EVENTHANDLER_NULLSET, EVENTHANDLER_REFERENCEINSERTION, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, HAS_NEXT_NAME, INFO_PREFIX, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, INTROSPECTOR_RESTRICT_CLASSES, INTROSPECTOR_RESTRICT_PACKAGES, MAX_NUMBER_LOOPS, NUMBER_OF_PARSERS, OUTPUT_ENCODING, PARSE_DIRECTIVE_MAXDEPTH, PARSER_POOL_CLASS, PARSER_POOL_SIZE, PROVIDE_SCOPE_CONTROL, RESOURCE_LOADER, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_DEFAULTCACHE_SIZE, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG, RUNTIME_LOG_ERROR_STACKTRACE, RUNTIME_LOG_INFO_STACKTRACE, RUNTIME_LOG_LOGSYSTEM, RUNTIME_LOG_LOGSYSTEM_CLASS, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_WARN_STACKTRACE, RUNTIME_REFERENCES_STRICT, RUNTIME_REFERENCES_STRICT_ESCAPE, SET_NULL_ALLOWED, SKIP_INVALID_ITERATOR, STRICT_MATH, TRACE_PREFIX, UBERSPECT_CLASSNAME, UNKNOWN_PREFIX, VM_ARGUMENTS_STRICT, VM_BODY_REFERENCE, VM_CONTEXT_LOCALSCOPE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_LIBRARY_DEFAULT, VM_MAX_DEPTH, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL, WARN_PREFIX`

Constructor Summary
`RuntimeInstance()` Creates a new RuntimeInstance object.

Method Summary
`void` | `addDirective(Directive directive)` Programatically add a directive.
`void` | `addProperty(String key, Object value)` Add a property to the configuration.
`boolean` | `addVelocimacro(String name, Node macro, String[] argArray, String sourceTemplate)` Adds a new Velocimacro.
`boolean` | `addVelocimacro(String name, String macro, String[] argArray, String sourceTemplate)` Deprecated. Use addVelocimacro(String, Node, String[], String) instead
`void` | `clearProperty(String key)` Clear the values pertaining to a particular property.
`Parser` | `createNewParser()` Returns a JavaCC generated Parser.
`void` | `debug(Object message)` Deprecated. Use getLog() and call debug() on it.
`boolean` | `dumpVMNamespace(String namespace)` tells the vmFactory to dump the specified namespace.
`void` | `error(Object message)` Deprecated. Use getLog() and call error() on it.
`boolean` | `evaluate(Context context, Writer writer, String logTag, Reader reader)` Renders the input reader using the context into the output writer.
`boolean` | `evaluate(Context context, Writer out, String logTag, String instring)` Renders the input string using the context into the output writer.
`Object` | `getApplicationAttribute(Object key)` Gets the application attribute for the given key
`EventCartridge` | `getApplicationEventCartridge()` Returns the event handlers for the application.
`boolean` | `getBoolean(String key, boolean def)` Boolean property accessor method to hide the configuration implementation.
`ExtendedProperties` | `getConfiguration()` Return the velocity runtime configuration object.
`ContentResource` | `getContent(String name)` Returns a static content resource from the resource manager.
`ContentResource` | `getContent(String name, String encoding)` Returns a static content resource from the resource manager.
`Directive` | `getDirective(String name)` Retrieve a previously instantiated directive.
`int` | `getInt(String key)` Int property accessor method to hide the configuration implementation.
`int` | `getInt(String key, int defaultValue)` Int property accessor method to hide the configuration implementation.
`Introspector` | `getIntrospector()` Return the Introspector for this instance
`String` | `getLoaderNameForResource(String resourceName)` Determines if a template exists and returns name of the loader that provides it.
`Log` | `getLog()` Returns a convenient Log instance that wraps the current LogChute.
`Object` | `getProperty(String key)` Allows an external caller to get a property.
`String` | `getString(String key)` String property accessor method to hide the configuration implementation
`String` | `getString(String key, String defaultValue)` String property accessor method with default to hide the configuration implementation.
`Template` | `getTemplate(String name)` Returns a `Template` from the resource manager.
`Template` | `getTemplate(String name, String encoding)` Returns a `Template` from the resource manager
`Uberspect` | `getUberspect()` Returns the Uberspect object for this Instance.
`Directive` | `getVelocimacro(String vmName, String templateName)` Returns the appropriate VelocimacroProxy object if vmName is a valid current Velocimacro.
`Directive` | `getVelocimacro(String vmName, String templateName, String renderingTemplate)` Returns the appropriate VelocimacroProxy object if vmName is a valid current Velocimacro.
`void` | `info(Object message)` Deprecated. Use getLog() and call info() on it.
`void` | `init()` This is the primary initialization method in the Velocity Runtime.
`void` | `init(Properties p)` Initialize the Velocity Runtime with a Properties object.
`void` | `init(String configurationFile)` Initialize the Velocity Runtime with the name of ExtendedProperties object.
`boolean` | `invokeVelocimacro(String vmName, String logTag, String[] params, Context context, Writer writer)` Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
`boolean` | `isInitialized()` Returns true if the RuntimeInstance has been successfully initialized.
`boolean` | `isVelocimacro(String vmName, String templateName)` Checks to see if a VM exists
`void` | `loadDirective(String directiveClass)` instantiates and loads the directive with some basic checks
`SimpleNode` | `parse(Reader reader, String templateName)` Parse the input and return the root of AST node structure.
`SimpleNode` | `parse(Reader reader, String templateName, boolean dumpNamespace)` Parse the input and return the root of the AST node structure.
`SimpleNode` | `parse(String string, String templateName)` Parse the input and return the root of AST node structure.
`void` | `removeDirective(String name)` Remove a directive.
`boolean` | `render(Context context, Writer writer, String logTag, SimpleNode nodeTree)` Initializes and renders the AST `SimpleNode` using the context into the output writer.
`Object` | `setApplicationAttribute(Object key, Object o)` Sets the application attribute for the given key
`void` | `setConfiguration(ExtendedProperties configuration)` Allow an external system to set an ExtendedProperties object to use.
`void` | `setProperties(Properties props)` Add all the properties in props to the RuntimeInstance properties
`void` | `setProperties(String fileName)` Add all properties contained in the file fileName to the RuntimeInstance properties
`void` | `setProperty(String key, Object value)` Allows an external system to set a property in the Velocity Runtime.
`void` | `warn(Object message)` Deprecated. Use getLog() and call warn() on it.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RuntimeInstance

    public RuntimeInstance()

  Creates a new RuntimeInstance object.

Method Detail

### init

    public void init()

  This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:
  - Logging System
  - ResourceManager
  - EventHandler
  - Parser Pool
  - Global Cache
  - Static Content Include System
  - Velocimacro System

  Specified by:
    `init` in interface `RuntimeServices`

### isInitialized

    public boolean isInitialized()

  Returns true if the RuntimeInstance has been successfully initialized.

  Specified by:
    `isInitialized` in interface `RuntimeServices`
  Returns:
    True if the RuntimeInstance has been successfully initialized.
  Since:
    1.5

### setProperty

    public void setProperty(String key,
                            Object value)

  Allows an external system to set a property in the Velocity Runtime.

  Specified by:
    `setProperty` in interface `RuntimeServices`
  Parameters:
    `key` - property key
    `value` - property value

### setProperties

    public void setProperties(String fileName)

  Add all properties contained in the file fileName to the RuntimeInstance properties

### setProperties

    public void setProperties(Properties props)

  Add all the properties in props to the RuntimeInstance properties

### setConfiguration

    public void setConfiguration(ExtendedProperties configuration)

  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.

  Specified by:
    `setConfiguration` in interface `RuntimeServices`
  Parameters:
    `configuration` -

### addProperty

    public void addProperty(String key,
                            Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

  Specified by:
    `addProperty` in interface `RuntimeServices`
  Parameters:
    `key` -
    `value` -

### clearProperty

    public void clearProperty(String key)

  Clear the values pertaining to a particular property.

  Specified by:
    `clearProperty` in interface `RuntimeServices`
  Parameters:
    `key` - of property to clear

### getProperty

    public Object getProperty(String key)

  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

  Specified by:
    `getProperty` in interface `RuntimeServices`
  Parameters:
    `key` - property to return
  Returns:
    Value of the property or null if it does not exist.

### init

    public void init(Properties p)

  Initialize the Velocity Runtime with a Properties object.

  Specified by:
    `init` in interface `RuntimeServices`
  Parameters:
    `p` - Velocity properties for initialization

### init

    public void init(String configurationFile)

  Initialize the Velocity Runtime with the name of ExtendedProperties object.

  Specified by:
    `init` in interface `RuntimeServices`
  Parameters:
    `configurationFile` -

### addDirective

    public void addDirective(Directive directive)

  Programatically add a directive.

  Parameters:
    `directive` -

### getDirective

    public Directive getDirective(String name)

  Retrieve a previously instantiated directive.

  Specified by:
    `getDirective` in interface `RuntimeServices`
  Parameters:
    `name` - name of the directive
  Returns:
    the `Directive` for that name

### removeDirective

    public void removeDirective(String name)

  Remove a directive.

  Parameters:
    `name` - name of the directive.

### loadDirective

    public void loadDirective(String directiveClass)

  instantiates and loads the directive with some basic checks

  Parameters:
    `directiveClass` - classname of directive to load

### createNewParser

    public Parser createNewParser()

  Returns a JavaCC generated Parser.

  Specified by:
    `createNewParser` in interface `RuntimeServices`
  Returns:
    Parser javacc generated parser

### parse

    public SimpleNode parse(String string,
                            String templateName)
                     throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Specified by:
    `parse` in interface `RuntimeServices`
  Parameters:
    `string` - String to be parsed
    `templateName` - name of the template being parsed
  Returns:
    A root node representing the template as an AST tree.
  Throws:
    `ParseException` - When the string could not be parsed as a template.
  Since:
    1.6

### parse

    public SimpleNode parse(Reader reader,
                            String templateName)
                     throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Specified by:
    `parse` in interface `RuntimeServices`
  Parameters:
    `reader` - Reader retrieved by a resource loader
    `templateName` - name of the template being parsed
  Returns:
    A root node representing the template as an AST tree.
  Throws:
    `ParseException` - When the template could not be parsed.

### parse

    public SimpleNode parse(Reader reader,
                            String templateName,
                            boolean dumpNamespace)
                     throws ParseException

  Parse the input and return the root of the AST node structure.

  Specified by:
    `parse` in interface `RuntimeServices`
  Parameters:
    `reader` - Reader retrieved by a resource loader
    `templateName` - name of the template being parsed
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template
  Returns:
    A root node representing the template as an AST tree.
  Throws:
    `ParseException` - When the template could not be parsed.

### evaluate

    public boolean evaluate(Context context,
                            Writer out,
                            String logTag,
                            String instring)

  Renders the input string using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Specified by:
    `evaluate` in interface `RuntimeServices`
  Parameters:
    `context` - context to use in rendering input string
    `out` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `instring` - input string containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity 1.6

### evaluate

    public boolean evaluate(Context context,
                            Writer writer,
                            String logTag,
                            Reader reader)

  Renders the input reader using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Specified by:
    `evaluate` in interface `RuntimeServices`
  Parameters:
    `context` - context to use in rendering input string
    `writer` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `reader` - Reader containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity 1.6

### render

    public boolean render(Context context,
                          Writer writer,
                          String logTag,
                          SimpleNode nodeTree)

  Initializes and renders the AST `SimpleNode` using the context into the output writer.

  Parameters:
    `context` - context to use in rendering input string
    `writer` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `nodeTree` - SimpleNode which is the root of the AST to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log for errors
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity 1.6

### invokeVelocimacro

    public boolean invokeVelocimacro(String vmName,
                                     String logTag,
                                     String[] params,
                                     Context context,
                                     Writer writer)

  Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
  Note : currently only accepts args to the VM if they are in the context.

  Specified by:
    `invokeVelocimacro` in interface `RuntimeServices`
  Parameters:
    `vmName` - name of Velocimacro to call
    `logTag` - string to be used for template name in case of error. if null, the vmName will be used
    `params` - keys for args used to invoke Velocimacro, in java format rather than VTL (eg "foo" or "bar" rather than "$foo" or "$bar")
    `context` - Context object containing data/objects used for rendering.
    `writer` - Writer for output stream
  Returns:
    true if Velocimacro exists and successfully invoked, false otherwise.
  Since:
    1.6

### getTemplate

    public Template getTemplate(String name)
                         throws ResourceNotFoundException,
                                ParseErrorException

  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"

  Specified by:
    `getTemplate` in interface `RuntimeServices`
  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getTemplate

    public Template getTemplate(String name,
                                String encoding)
                         throws ResourceNotFoundException,
                                ParseErrorException

  Returns a `Template` from the resource manager

  Specified by:
    `getTemplate` in interface `RuntimeServices`
  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getContent

    public ContentResource getContent(String name)
                               throws ResourceNotFoundException,
                                      ParseErrorException

  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

  Specified by:
    `getContent` in interface `RuntimeServices`
  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - When the template could not be parsed.

### getContent

    public ContentResource getContent(String name,
                                      String encoding)
                               throws ResourceNotFoundException,
                                      ParseErrorException

  Returns a static content resource from the resource manager.

  Specified by:
    `getContent` in interface `RuntimeServices`
  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - When the template could not be parsed.

### getLoaderNameForResource

    public String getLoaderNameForResource(String resourceName)

  Determines if a template exists and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.resourceExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

  Specified by:
    `getLoaderNameForResource` in interface `RuntimeServices`
  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it

### getLog

    public Log getLog()

  Returns a convenient Log instance that wraps the current LogChute. Use this to log error messages. It has the usual methods.

  Specified by:
    `getLog` in interface `RuntimeServices`
  Returns:
    A convenience Log instance that wraps the current LogChute.
  Since:
    1.5

### warn

    public void warn(Object message)

  Deprecated. Use getLog() and call warn() on it.

  Specified by:
    `warn` in interface `RuntimeLogger`
  Parameters:
    `message` - The message to log.
  See Also:
    `Log.warn(Object)`

### info

    public void info(Object message)

  Deprecated. Use getLog() and call info() on it.

  Specified by:
    `info` in interface `RuntimeLogger`
  Parameters:
    `message` - The message to log.
  See Also:
    `Log.info(Object)`

### error

    public void error(Object message)

  Deprecated. Use getLog() and call error() on it.

  Specified by:
    `error` in interface `RuntimeLogger`
  Parameters:
    `message` - The message to log.
  See Also:
    `Log.error(Object)`

### debug

    public void debug(Object message)

  Deprecated. Use getLog() and call debug() on it.

  Specified by:
    `debug` in interface `RuntimeLogger`
  Parameters:
    `message` - The message to log.
  See Also:
    `Log.debug(Object)`

### getString

    public String getString(String key,
                            String defaultValue)

  String property accessor method with default to hide the configuration implementation.

  Specified by:
    `getString` in interface `RuntimeServices`
  Parameters:
    `key` - property key
    `defaultValue` - default value to return if key not found in resource manager.
  Returns:
    value of key or default

### getVelocimacro

    public Directive getVelocimacro(String vmName,
                                    String templateName)

  Returns the appropriate VelocimacroProxy object if vmName is a valid current Velocimacro.

  Specified by:
    `getVelocimacro` in interface `RuntimeServices`
  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - Name of the template that contains the velocimacro.
  Returns:
    The requested VelocimacroProxy.
  Since:
    1.6

### getVelocimacro

    public Directive getVelocimacro(String vmName,
                                    String templateName,
                                    String renderingTemplate)

  Returns the appropriate VelocimacroProxy object if vmName is a valid current Velocimacro.

  Specified by:
    `getVelocimacro` in interface `RuntimeServices`
  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - Name of the namespace.
    `renderingTemplate` - Name of the template we are currently rendering. This information is needed when VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL setting is true and template contains a macro with the same name as the global macro library.
  Returns:
    VelocimacroProxy
  Since:
    Velocity 1.6

### addVelocimacro

    public boolean addVelocimacro(String name,
                                  String macro,
                                  String[] argArray,
                                  String sourceTemplate)

  Deprecated. Use addVelocimacro(String, Node, String[], String) instead

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Specified by:
    `addVelocimacro` in interface `RuntimeServices`
  Parameters:
    `name` - Name of velocimacro
    `macro` - String form of macro body
    `argArray` - Array of strings, containing the #macro() arguments. the 0th is the name.
    `sourceTemplate` - Name of the template that contains the velocimacro.
  Returns:
    True if added, false if rejected for some reason (either parameters or permission settings)

### addVelocimacro

    public boolean addVelocimacro(String name,
                                  Node macro,
                                  String[] argArray,
                                  String sourceTemplate)

  Adds a new Velocimacro. Usually called by Macro only while parsing. Called by org.apache.velocity.runtime.directive.processAndRegister

  Specified by:
    `addVelocimacro` in interface `RuntimeServices`
  Parameters:
    `name` - Name of velocimacro
    `macro` - root AST node of the parsed macro
    `argArray` - Array of strings, containing the #macro() arguments. the 0th is the name.
    `sourceTemplate` -
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)
  Since:
    Velocity 1.6

### isVelocimacro

    public boolean isVelocimacro(String vmName,
                                 String templateName)

  Checks to see if a VM exists

  Specified by:
    `isVelocimacro` in interface `RuntimeServices`
  Parameters:
    `vmName` - Name of the Velocimacro.
    `templateName` - Template on which to look for the Macro.
  Returns:
    True if VM by that name exists, false if not

### dumpVMNamespace

    public boolean dumpVMNamespace(String namespace)

  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

  Specified by:
    `dumpVMNamespace` in interface `RuntimeServices`
  Parameters:
    `namespace` - Namespace to dump.
  Returns:
    True if namespace was dumped successfully.

### getString

    public String getString(String key)

  String property accessor method to hide the configuration implementation

  Specified by:
    `getString` in interface `RuntimeServices`
  Parameters:
    `key` - property key
  Returns:
    value of key or null

### getInt

    public int getInt(String key)

  Int property accessor method to hide the configuration implementation.

  Specified by:
    `getInt` in interface `RuntimeServices`
  Parameters:
    `key` - Property key
  Returns:
    value

### getInt

    public int getInt(String key,
                      int defaultValue)

  Int property accessor method to hide the configuration implementation.

  Specified by:
    `getInt` in interface `RuntimeServices`
  Parameters:
    `key` - property key
    `defaultValue` - The default value.
  Returns:
    value

### getBoolean

    public boolean getBoolean(String key,
                              boolean def)

  Boolean property accessor method to hide the configuration implementation.

  Specified by:
    `getBoolean` in interface `RuntimeServices`
  Parameters:
    `key` - property key
    `def` - The default value if property not found.
  Returns:
    value of key or default value

### getConfiguration

    public ExtendedProperties getConfiguration()

  Return the velocity runtime configuration object.

  Specified by:
    `getConfiguration` in interface `RuntimeServices`
  Returns:
    Configuration object which houses the Velocity runtime properties.

### getIntrospector

    public Introspector getIntrospector()

  Return the Introspector for this instance

  Specified by:
    `getIntrospector` in interface `RuntimeServices`
  Returns:
    The Introspector for this instance

### getApplicationEventCartridge

    public EventCartridge getApplicationEventCartridge()

  Returns the event handlers for the application.

  Specified by:
    `getApplicationEventCartridge` in interface `RuntimeServices`
  Returns:
    The event handlers for the application.
  Since:
    1.5

### getApplicationAttribute

    public Object getApplicationAttribute(Object key)

  Gets the application attribute for the given key

  Specified by:
    `getApplicationAttribute` in interface `RuntimeServices`
  Parameters:
    `key` -
  Returns:
    The application attribute for the given key.

### setApplicationAttribute

    public Object setApplicationAttribute(Object key,
                                          Object o)

  Sets the application attribute for the given key

  Specified by:
    `setApplicationAttribute` in interface `RuntimeServices`
  Parameters:
    `key` -
    `o` - The new application attribute.
  Returns:
    The old value of this attribute or null if it hasn't been set before.

### getUberspect

    public Uberspect getUberspect()

  Returns the Uberspect object for this Instance.

  Specified by:
    `getUberspect` in interface `RuntimeServices`
  Returns:
    The Uberspect object for this Instance.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.